﻿using System.Collections.Generic;
using HarmonyLib;
using UnityEngine;
using UnityEngine.UI;
using static Config;
using ModDeclaration;
using UnityEngine.EventSystems;

namespace MoreNativeSpeed { 
    public static class SpeedModifier {
    public static Image CurrentSpeedIcon = null;

    public static Sprite iconClockX10 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX10.png");
    public static Sprite iconClockX15 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX15.png");
    public static Sprite iconClockX20 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX20.png");
    public static Sprite iconClockX30 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX30.png");
    public static Sprite iconClockX50 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX50.png");
    public static Sprite iconClockX100 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX100.png");
    public static Sprite iconClockX150 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX150.png");
    public static Sprite iconClockX200 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX200.png");
    public static Sprite iconClockX300 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX300.png");
    public static Sprite iconClockX500 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX500.png");
    public static Sprite iconClockX750 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX750.png");
    public static Sprite iconClockX1000 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX1000.png");
    public static Sprite iconClockX2000 = Mod.EmbededResources.LoadSprite("MoreNativeSpeed.Resources.iconClockX2000.png");
    
    [HarmonyPostfix]
    [HarmonyPatch(typeof(PowerButton), "init")]
    public static void postInit(ref PowerButton __instance)
    {
        if (__instance.type == PowerButtonType.TimeScale && int.Parse(__instance.transform.name) == 5)
        {
            time_scales = new Dictionary<int, float>
            {
                { 0, 0.5f },
                { 1, 1f },
                { 2, 2f },
                { 3, 3f },
                { 4, 4f },
                { 5, 5f },
                { 6, 10f },
                { 7, 15f },
                { 8, 20f },
                { 9, 30f },
                { 10, 50f },
                { 11, 100f },
                { 12, 150f },
                { 13, 200f },
                { 14, 300f },
                { 15, 500f },
                { 16, 750f },
                { 17, 1000f },
                { 18, 2000f },
                { 40, 40f }
            };
            time_scales_list = new List<float>
            {
                0.5f,
                1f,
                2f,
                3f,
                4f,
                5f,
                10f,
                15f,
                20f,
                30f,
                50f,
                100f,
                150f,
                200f,
                300f,
                500f,
                750f,
                1000f,
                2000f,
                40f
            };

            Vector3 space = __instance.transform.localPosition - MapBox.instance.selectedButtons.clockButton
                .sizeButtons.transform.GetChild(4).transform.localPosition;
            GameObject newObj_6 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_6.name = "6";
            newObj_6.transform.localPosition = __instance.transform.localPosition + space;
            newObj_6.transform.GetChild(0).GetComponent<Text>().text = "x10";
            newObj_6.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX10;

            GameObject newObj_7 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_7.name = "7";
            newObj_7.transform.localPosition = __instance.transform.localPosition + space * 2;
            newObj_7.transform.GetChild(0).GetComponent<Text>().text = "x15";
            newObj_7.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX15;

            GameObject newObj_8 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_8.name = "8";
            newObj_8.transform.localPosition = __instance.transform.localPosition + space * 3;
            newObj_8.transform.GetChild(0).GetComponent<Text>().text = "x20";
            newObj_8.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX20;

            GameObject newObj_9 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_9.name = "9";
            newObj_9.transform.localPosition = __instance.transform.localPosition + space * 4;
            newObj_9.transform.GetChild(0).GetComponent<Text>().text = "x30";
            newObj_9.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX30;

            GameObject newObj_10 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_10.name = "10";
            newObj_10.transform.localPosition = __instance.transform.localPosition + space * 5;
            newObj_10.transform.GetChild(0).GetComponent<Text>().text = "x50";
            newObj_10.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX50;

            GameObject newObj_11 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_11.name = "11";
            newObj_11.transform.localPosition = __instance.transform.localPosition + space * 6;
            newObj_11.transform.GetChild(0).GetComponent<Text>().text = "x100";
            newObj_11.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX100;
            
            GameObject newObj_12 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_12.name = "12";
            newObj_12.transform.localPosition = __instance.transform.localPosition + space * 7;
            newObj_12.transform.GetChild(0).GetComponent<Text>().text = "x150";
            newObj_12.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX150;

            GameObject newObj_13 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_13.name = "13";
            newObj_13.transform.localPosition = __instance.transform.localPosition + space * 8;
            newObj_13.transform.GetChild(0).GetComponent<Text>().text = "x200";
            newObj_13.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX200;

            GameObject newObj_14 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_14.name = "14";
            newObj_14.transform.localPosition = __instance.transform.localPosition + space * 9;
            newObj_14.transform.GetChild(0).GetComponent<Text>().text = "x300";
            newObj_14.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX300;

            GameObject newObj_15 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_15.name = "15";
            newObj_15.transform.localPosition = __instance.transform.localPosition + space * 10;
            newObj_15.transform.GetChild(0).GetComponent<Text>().text = "x500";
            newObj_15.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX500;

            GameObject newObj_16 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_16.name = "16";
            newObj_16.transform.localPosition = __instance.transform.localPosition + space * 11;
            newObj_16.transform.GetChild(0).GetComponent<Text>().text = "x750";
            newObj_16.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX750;

            GameObject newObj_17 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_17.name = "17";
            newObj_17.transform.localPosition = __instance.transform.localPosition + space * 12;
            newObj_17.transform.GetChild(0).GetComponent<Text>().text = "x1000";
            newObj_17.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX1000;

            GameObject newObj_18 = GameObject.Instantiate(__instance.gameObject, __instance.transform.parent);
            newObj_18.name = "18";
            newObj_18.transform.localPosition = __instance.transform.localPosition + space * 13;
            newObj_18.transform.GetChild(0).GetComponent<Text>().text = "x2000";
            newObj_18.transform.GetChild(1).gameObject.GetComponent<Image>().sprite = iconClockX2000;

            
        }
    }
    [HarmonyPostfix]
    [HarmonyPatch(typeof(PowerClockButton), "Update")]
    public static void postUpdate(ref PowerButton __instance)
    {
        if (CurrentSpeedIcon == null)
            CurrentSpeedIcon = Traverse.Create(__instance).Field("currentSpeedIcon").GetValue() as Image;
        var clockIcon = PowerButton.get("clock").transform.GetChild(3).GetComponent<Image>();
        float latestUsed = Config.timeScale;
        if ((double) latestUsed != 10.0)
        {
            if ((double) latestUsed != 15.0)
            {
                if ((double) latestUsed != 20.0)
                {
                    if ((double) latestUsed != 30.0)
                    {
                        if ((double) latestUsed != 50.0)
                        {
                            if ((double) latestUsed != 100.0)
                            {
                                if ((double) latestUsed != 150.0)
                                {
                                    if ((double) latestUsed != 200.0)
                                    {
                                        if ((double) latestUsed != 300.0)
                                        {
                                            if ((double) latestUsed != 500.0)
                                            {
                                                if ((double) latestUsed != 750.0)
                                                {
                                                    if ((double) latestUsed != 1000.0)
                                                    {
                                                        if ((double) latestUsed != 2000.0)
                                                            return;
                                                        CurrentSpeedIcon.sprite = iconClockX2000;
                                                        clockIcon.sprite = iconClockX2000;
                                                    }
                                                    else
                                                    {
                                                        CurrentSpeedIcon.sprite = iconClockX1000;
                                                        clockIcon.sprite = iconClockX1000;
                                                    }
                                                }
                                                else
                                                {
                                                    CurrentSpeedIcon.sprite = iconClockX750;
                                                    clockIcon.sprite = iconClockX750;
                                                }
                                            }
                                            else
                                            {
                                                CurrentSpeedIcon.sprite = iconClockX500;
                                                clockIcon.sprite = iconClockX500;
                                            }
                                        }
                                        else
                                        {
                                            CurrentSpeedIcon.sprite = iconClockX300;
                                            clockIcon.sprite = iconClockX300;
                                        }
                                    }
                                    else
                                    {
                                        CurrentSpeedIcon.sprite = iconClockX200;
                                        clockIcon.sprite = iconClockX200;
                                    }
                                }
                                else
                                {
                                    CurrentSpeedIcon.sprite = iconClockX150;
                                    clockIcon.sprite = iconClockX150;
                                }
                            }
                            else
                            {
                            CurrentSpeedIcon.sprite = iconClockX100;
                            clockIcon.sprite = iconClockX100;
                            }
                        }
                        else
                        {
                            CurrentSpeedIcon.sprite = iconClockX50;
                            clockIcon.sprite = iconClockX50;
                        }
                    }
                    else
                    {
                        CurrentSpeedIcon.sprite = iconClockX30;
                        clockIcon.sprite = iconClockX30;
                    }

                }
                else
                {
                    CurrentSpeedIcon.sprite = iconClockX20;
                    clockIcon.sprite = iconClockX20;
                }
            }
            else
            {
                CurrentSpeedIcon.sprite = iconClockX15;
                clockIcon.sprite = iconClockX15;
            }
        }
        else
        {
            CurrentSpeedIcon.sprite = iconClockX10;
            clockIcon.sprite = iconClockX10;
        }
    }
    }
}
